@make(text)

@begin(transparent, size +6)
@center{Transparencies and Handouts for
@b[TAQL Tutorial]}
@end(transparent)

@center{EuroSoar-4 Workshop
Twente University, Enschede, NL
January 18, 1991}

@begin(center, spread 0.3)
@b[Gregg Yost & Erik Altmann]
School of Computer Science
Carnegie Mellon University
gry@@cs.cmu.edu, altmann@@cs.cmu.edu

File: @begin(transparent, size -2)@value(FullManuscript)@end(transparent)
Current Version: @value(RootFileDate)

@i[The tutorial files are all in the taql-tutorial subdirectory of the directory TAQL is installed in at your site.
The files are also available in @w{/afs/cs.cmu.edu/project/soar/member/gry/taql-tutorial}.]

@begin(transparent, size +2)
TABLE OF CONTENTS
@end(transparent)
@end(center)
@begin(transparent, leftmargin +.75inch)
@begin(format, Group)
@tabclear@tabset(3,6,9,12,15,18,21,24,27,30,33,36,39,42,45)

@\Tutorial transparencies

@\@i(Monkey and Bananas example:)
@\@\spec-handout-1.txt - task description, behavior specification
@\@\space-spec.txt - abstract specification
@\@\data-spec.txt - specification for data representation
@\@\mab.taql - source file for Monkey and Bananas (used throughout)
@\@\smarter-monkey.taql - search control to load on top of mab.taql

@\Problem Set 1 and Hands-on TAQL Script
@\@i(Solution to problem set 1:)
@\@\mea-monkey.taql 

@\@i[Member operator example (multiple problem spaces):]
@\@\member.taql - implementation of member operator
@\@\member-driver.taql
@\@\member.trace

@\Problem Set 2 - implement insert-after, using member operator
@\@i(Solution to problem set 2:)
@\@\insert-after.taql
@\@\insert-driver.taql
@\@\insert-after.trace

@\@i[Selection space example (with Monkey and Bananas):]
@\@\hill-climb.taql - the TCs that generate hill-climbing behavior
@\@\depth-first.taql - the TCs that generate depth-first behavior
@\@\selection.trace - two Mab runs with different uses of selection space

@\Problem Set 3 - selection space exercises (blocks world, traveling realtor)
@\@\stub.taql - template for blocks-world solution
@\@i(Solution to problem set 3:)
@\@\blocks.taql - uses depth-first search with cycle detection
@\@\blocks.trace
@\@\trav.taql - uses two-level lookahead with numeric evaluations
@\@\trav.trace
@end(format)
@end(transparent)
